local sti = require "lib.sti"

-- implementing a really basic camera
-- from http://nova-fusion.com/2011/04/19/cameras-in-love2d-part-1-the-basics
camera = {}
camera.x = 0
camera.y = 0

function camera:set()
  love.graphics.push()
  love.graphics.translate(-self.x, -self.y)
end

function camera:unset()
  love.graphics.pop()
end

function camera:move(dx, dy)
  self.x = self.x + (dx or 0)
  self.y = self.y + (dy or 0)
end

function camera:setPosition(x, y)
  self.x = x or self.x
  self.y = y or self.y
end


function love.load()

    -- use sti to load 4 maps
    -- all are 512px by 512px
    -- 32 tiles by 32 tiles, 16px tiles

    -- use offset params to position them in a square
    -- [map1] [map2]
    -- [map3] [map4]
    map1 = sti("map001.lua", {}, 0, 0)
    map2 = sti("map002.lua", {}, 512, 0)
    map3 = sti("map003.lua", {}, 0, 512)
    map4 = sti("map004.lua", {}, 512, 512)
end

function love.draw()
  camera:set()

  -- draw all four maps
  map1:draw()
  map2:draw()
  map3:draw()

  -- only last map drawn will be displayed
  -- rearranging draw calls will illustrated the problem
  map4:draw()

  camera:unset()
end

function love.update(dt)
  -- use camera to pan down through around the "world"
  camera:move(64 * dt, 64 * dt)
end
